#ifndef KMEANS_INTERFACE_H_
#define KMEANS_INTERFACE_H_

#include<interface.h>

  const ArgsDef  args_kmeans[] = {
      {'N', "n-of-clusters", arg_req_arg, "Number of outcome clusters", ""},
      {'s', "seed", arg_req_arg, "Random seed, default=-1 (random, i.e. time dependant)", ""},
      {'b', "best", arg_no_arg, "return only the best cluster, if multiple where created", ""},
      {'v', "vector", arg_no_arg, "treat each row in graph as a position in euclidean space; default treats graph as a disimilarity graph.", ""},
      {'V', "r-vector", arg_no_arg, "treat each row in graph as a position in euclidean space; Computed with the use of R-cran software. REQUIRES R binary in the PATH", ""},
      {'a', "initial-clusters", arg_req_arg, "file (space/newline separated) with numbers of assignment of each gene to a specific cluster.", ""},
      {'A', "save-clusters", arg_req_arg, "(out) file with numbers of assignment of each gene to a specific cluster.", ""},
      {'I', "max-iterations", arg_req_arg, "the maximal number of iterations.", ""},
      {0, "", arg_no_arg, "A package that clusters similar vertices in graph into groups", ""}
      };

namespace kmeans{
  InterfaceFunction;
  const InterfaceFlow interfaceFlow( InterfaceFlow::Graph, 
                                     InterfaceFlow::Results);
}

#endif /*KMEANS_INTERFACE_H_*/
