#ifndef TIMER_H_
#define TIMER_H_

#include <map>
#include <list>
#include <string>
#include<stdio.h>

namespace timer{

using namespace std;
//  class TimeBins;
//  class TimeBin : public deque<pair<long, long>>{
//    const string name;
//    deque<TimeBins> timeBins;
// };
//  class TimeBins : public deque<TimeBin>{
//  };

  class TimerSet{
  
    private:
    TimerSet();
    map<string, list<pair<long, long> > > timers;
    map<string, long> summary;


    double ticksPerSecond; 
    double getTime();
    double computeTicksPerSecond();

    public:
    void print(FILE * f);
    double getTicksPerSecond(){
      return ticksPerSecond;
    }
    double getSummary(const string & name){
      return summary[name] / ticksPerSecond;
    }
    ~TimerSet();
    static TimerSet * getInstance();
    void addTime(string const & name, const long & start, const long & stop);
  };
  
  class Timer{
    private:
    long started;
    long stopped;
    string name;
    int running;
  
    public:
    Timer(char const * name);
    ~Timer();
  
    void start();
    double stop();
  };
}

#endif /*TIMER_H_*/
